import 'package:cloud_firestore/cloud_firestore.dart';
import 'package:wowit/methods.dart';


class BaseModel {
  DocumentSnapshot documentSnapshot;
  int documentID;
  String documentDocumentSnapshotID;
  int statusData;

  BaseModel(DocumentSnapshot _document) {
    documentSnapshot = _document;
    initBaseData(documentSnapshot);
  }

  void initBaseData(DocumentSnapshot _document) {
    if (!_document.exists) {
      print(this.runtimeType.toString() + ' - initBaseData is not exists');
      return;
    }
    documentDocumentSnapshotID = _document.id;
    var data = _document.data();
    documentID = Methods.getDataHashMapInt(data, 'documentID');
    statusData = Methods.getDataHashMapInt(data, 'statusData');
    if (documentID.toString() != documentDocumentSnapshotID) {
      print(this.runtimeType.toString() +
          ' - WARNING documentID != documentDocumentSnapshotID [ ' +
          documentID.toString() +
          ' != ' +
          documentDocumentSnapshotID +
          ']');
      return;
    }
  }
}
